package io.paulik.mqtt.client;


import org.eclipse.paho.client.mqttv3.*;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.concurrent.TimeUnit;

/**
 * Hello world!
 */
public class App {
    public static void main(String[] args) throws MqttException, UnsupportedEncodingException, InterruptedException {

        Path path0 = Paths.get("uc1start.txt");
        Path path1 = Paths.get("uc1end.txt");
        BufferedWriter writer, writer2;
        try {
            writer = Files.newBufferedWriter(path0);
            writer2 = Files.newBufferedWriter(path1);

            MqttClient client = new MqttClient(
                    "tcp://localhost:1883", //URI
                    MqttClient.generateClientId(), //ClientId
                    new MemoryPersistence()); //Persistence


            MqttConnectOptions options = new MqttConnectOptions();
            options.setMqttVersion(MqttConnectOptions.MQTT_VERSION_3_1_1);
            options.setUserName("admin");
            options.setPassword("admin".toCharArray());
            client.connect(options);

            client.publish(
                    "topica", // topic
                    "payload".getBytes("UTF-8"), // payload
                    2, // QoS
                    false); // retained?


            client.setCallback(new MqttCallback() {

                public void connectionLost(Throwable cause) { //Called when the client lost the connection to the broker
                }

                public void messageArrived(String topic, MqttMessage message) throws Exception {
                    //System.out.println(topic + ": " + new String(message.getPayload()));

                }

                public void deliveryComplete(IMqttDeliveryToken token) {//Called when a outgoing publish is complete
                }
            });

            client.subscribe("hahar", 1);

            TimeUnit.MINUTES.sleep(1);

            client.disconnect();

            writer.close();
            writer2.close();

        }catch (IOException e){}

    }


}
