package io.paulik.camel.rest;


import io.silverspoon.bulldog.core.gpio.DigitalOutput;
import io.silverspoon.bulldog.core.platform.Board;
import io.silverspoon.bulldog.core.platform.Platform;
import io.silverspoon.bulldog.raspberrypi.RaspiNames;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.model.rest.RestBindingMode;
import org.springframework.stereotype.Component;

@Component
public class UseCase1RestBuilder extends RouteBuilder {
    public void configure() throws Exception {

        restConfiguration().component("restlet").host("localhost").port(8080); //.bindingMode(RestBindingMode.auto)

        rest("/")
                .post("/gpio/1").to("direct:gpio1");

        from("direct:gpio1").process(new Processor() {
            public void process(Exchange exchange) throws Exception {
                exchange.getOut().setHeader(Exchange.HTTP_RESPONSE_CODE, 204);
                String postValue = exchange.getIn().getBody(String.class);
                // TODO: 4/21/17 set pin HIGH/LOW
                if("1".equals(postValue)){
                    Board board = Platform.createBoard();
                    //Set up a digital output
                    DigitalOutput output = board.getPin(RaspiNames.P1_11).as(DigitalOutput.class);
                    //Blink the LED
                    output.high();
                }else{
                    Board board = Platform.createBoard();

                    //Set up a digital output
                    DigitalOutput output = board.getPin(RaspiNames.P1_11).as(DigitalOutput.class);

                    //Blink the LED
                    output.low();
                }
            }
        });
    }
}
