package io.paulik.camel.socket;

import io.silverspoon.bulldog.core.gpio.DigitalOutput;
import io.silverspoon.bulldog.core.platform.Board;
import io.silverspoon.bulldog.core.platform.Platform;
import io.silverspoon.bulldog.raspberrypi.RaspiNames;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.json.JSONObject;

public class UseCase1SocketBuilder extends RouteBuilder{
    public void configure() throws Exception {
        from("netty:tcp://localhost:8888?sync=true&textline=true").process(new Processor() {
            public void process(Exchange exchange) throws Exception {
                System.out.println(exchange.getIn().getBody(String.class));
                JSONObject jsonObject = new JSONObject(exchange.getIn().getBody(String.class));
                if("1".equals(jsonObject.getString("pin"))){
                    Board board = Platform.createBoard();
                    //Set up a digital output
                    DigitalOutput output = board.getPin(RaspiNames.P1_11).as(DigitalOutput.class);
                    //Blink the LED
                    output.high();
                }else{
                    Board board = Platform.createBoard();

                    //Set up a digital output
                    DigitalOutput output = board.getPin(RaspiNames.P1_11).as(DigitalOutput.class);

                    //Blink the LED
                    output.low();
                }
                exchange.getOut().setBody("{\"status\":\"ok\"}");
            }
        });
    }
}
