package io.paulik.camel.socket;

import io.silverspoon.bulldog.core.io.bus.i2c.I2cBus;
import io.silverspoon.bulldog.core.platform.Board;
import io.silverspoon.bulldog.core.platform.Platform;
import io.silverspoon.bulldog.devices.sensors.BH1750LightIntensitySensor;
import io.silverspoon.bulldog.raspberrypi.RaspiNames;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.json.JSONObject;

/**
 * Created by apaulik on 4/29/17.
 */
public class UseCase2SockerBuilder extends RouteBuilder {
    public void configure() throws Exception {
        from("netty:tcp://localhost:8888?sync=true&textline=true")
                .process(new Processor() {
                             public void process(Exchange exchange) throws Exception {
                                 System.out.println(exchange.getIn().getBody(String.class));
                                 JSONObject jsonObject = new JSONObject(exchange.getIn().getBody(String.class));

                                 if (jsonObject.has("device")
                                         && "bh1750".equals(jsonObject.getString("device"))
                                         && "readLuminanceNormalized".equals(jsonObject.getString("method"))) {

                                     // TODO: 4/29/17 buldog read value

                                     //Detect the board we are running on
                                     Board board = Platform.createBoard();

                                     //Set up a digital output
                                     //DigitalOutput output = board.getPin(RaspiNames.P1_11).as(DigitalOutput.class);

                                     //Blink the LED
                                     //output.high();
                                     //BulldogUtil.sleepMs(1000);
                                     //output.low();

                                     I2cBus bus = board.getI2cBus(RaspiNames.I2C_1);

                                     // Let's assume we have got a device on address xx
                                     BH1750LightIntensitySensor sensor = new BH1750LightIntensitySensor(bus, 0x23);
                                     sensor.initMode(BH1750LightIntensitySensor.MODE_HIGH_RES_05_LX_CONTINUOUS);


                                     // TODO: 4/29/17 put value to json
                                     double luminosity = sensor.readLuminanceNormalized();
                                     jsonObject.put("return", luminosity);

                                     exchange.getOut().setBody(jsonObject.toString());
                                 } else {
                                     exchange.getOut().setBody("{\"status\":\"ko\"}");
                                 }
                             }
                         }
                );
    }
}
